/* Plug.c generated by valac 0.56.14, the Vala compiler
 * generated from Plug.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "bluetooth.h"
#include <switchboard.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

enum  {
	BLUETOOTH_PLUG_0_PROPERTY,
	BLUETOOTH_PLUG_NUM_PROPERTIES
};
static GParamSpec* bluetooth_plug_properties[BLUETOOTH_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BluetoothPlugSearchData BluetoothPlugSearchData;

struct _BluetoothPlugPrivate {
	BluetoothMainView* main_view;
	BluetoothServicesObjectManager* manager;
};

struct _BluetoothPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
};

static gint BluetoothPlug_private_offset;
static gpointer bluetooth_plug_parent_class = NULL;

static GtkWidget* bluetooth_plug_real_get_widget (SwitchboardPlug* base);
static void ___lambda34_ (BluetoothPlug* self);
static void ____lambda34__bluetooth_main_view_quit_plug (BluetoothMainView* _sender,
                                                  gpointer self);
static void bluetooth_plug_real_shown (SwitchboardPlug* base);
static void bluetooth_plug_real_hidden (SwitchboardPlug* base);
static void bluetooth_plug_real_search_callback (SwitchboardPlug* base,
                                          const gchar* location);
static void bluetooth_plug_real_search_data_free (gpointer _data);
static void bluetooth_plug_real_search (SwitchboardPlug* base,
                                 const gchar* search,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static gboolean bluetooth_plug_real_search_co (BluetoothPlugSearchData* _data_);
static void bluetooth_plug_finalize (GObject * obj);
static GType bluetooth_plug_get_type_once (void);

static inline gpointer
bluetooth_plug_get_instance_private (BluetoothPlug* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothPlug_private_offset);
}

BluetoothPlug*
bluetooth_plug_construct (GType object_type)
{
	BluetoothPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
	BluetoothServicesObjectManager* _tmp1_;
	BluetoothServicesObjectManager* _tmp2_;
#line 26 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 26 "../src/Plug.vala"
	settings = _tmp0_;
#line 27 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "network/bluetooth", NULL);
#line 28 "../src/Plug.vala"
	self = (BluetoothPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_NETWORK, "code-name", "io.elementary.switchboard.bluetooth", "display-name", _ ("Bluetooth"), "description", _ ("Configure Bluetooth Settings"), "icon", "bluetooth", "supported-settings", settings, NULL);
#line 35 "../src/Plug.vala"
	_tmp1_ = bluetooth_services_object_manager_new ();
#line 35 "../src/Plug.vala"
	_g_object_unref0 (self->priv->manager);
#line 35 "../src/Plug.vala"
	self->priv->manager = _tmp1_;
#line 36 "../src/Plug.vala"
	_tmp2_ = self->priv->manager;
#line 36 "../src/Plug.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp2_, "has-object", (GObject*) self, "can-show", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 25 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 25 "../src/Plug.vala"
	return self;
#line 121 "Plug.c"
}

BluetoothPlug*
bluetooth_plug_new (void)
{
#line 25 "../src/Plug.vala"
	return bluetooth_plug_construct (BLUETOOTH_TYPE_PLUG);
#line 129 "Plug.c"
}

static void
___lambda34_ (BluetoothPlug* self)
{
#line 42 "../src/Plug.vala"
	switchboard_plug_hidden ((SwitchboardPlug*) self);
#line 137 "Plug.c"
}

static void
____lambda34__bluetooth_main_view_quit_plug (BluetoothMainView* _sender,
                                             gpointer self)
{
#line 42 "../src/Plug.vala"
	___lambda34_ ((BluetoothPlug*) self);
#line 146 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "Plug.c"
}

static GtkWidget*
bluetooth_plug_real_get_widget (SwitchboardPlug* base)
{
	BluetoothPlug * self;
	BluetoothMainView* _tmp0_;
	BluetoothMainView* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* result;
#line 39 "../src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 40 "../src/Plug.vala"
	_tmp0_ = self->priv->main_view;
#line 40 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 171 "Plug.c"
		BluetoothServicesObjectManager* _tmp1_;
		BluetoothMainView* _tmp2_;
		BluetoothMainView* _tmp3_;
#line 41 "../src/Plug.vala"
		_tmp1_ = self->priv->manager;
#line 41 "../src/Plug.vala"
		_tmp2_ = bluetooth_main_view_new (_tmp1_);
#line 41 "../src/Plug.vala"
		g_object_ref_sink (_tmp2_);
#line 41 "../src/Plug.vala"
		_g_object_unref0 (self->priv->main_view);
#line 41 "../src/Plug.vala"
		self->priv->main_view = _tmp2_;
#line 42 "../src/Plug.vala"
		_tmp3_ = self->priv->main_view;
#line 42 "../src/Plug.vala"
		g_signal_connect_object (_tmp3_, "quit-plug", (GCallback) ____lambda34__bluetooth_main_view_quit_plug, self, 0);
#line 189 "Plug.c"
	}
#line 45 "../src/Plug.vala"
	_tmp4_ = self->priv->main_view;
#line 45 "../src/Plug.vala"
	_tmp5_ = _g_object_ref0 ((GtkWidget*) _tmp4_);
#line 45 "../src/Plug.vala"
	result = _tmp5_;
#line 45 "../src/Plug.vala"
	return result;
#line 199 "Plug.c"
}

static void
bluetooth_plug_real_shown (SwitchboardPlug* base)
{
	BluetoothPlug * self;
	BluetoothServicesObjectManager* _tmp0_;
	BluetoothMainView* _tmp1_;
	GtkWidget* _tmp2_;
	BluetoothServicesObjectManager* _tmp3_;
#line 48 "../src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 49 "../src/Plug.vala"
	_tmp0_ = self->priv->manager;
#line 49 "../src/Plug.vala"
	_tmp1_ = self->priv->main_view;
#line 49 "../src/Plug.vala"
	_tmp2_ = gtk_widget_get_toplevel ((GtkWidget*) _tmp1_);
#line 49 "../src/Plug.vala"
	bluetooth_services_object_manager_register_agent (_tmp0_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp2_) : NULL, NULL, NULL);
#line 50 "../src/Plug.vala"
	_tmp3_ = self->priv->manager;
#line 50 "../src/Plug.vala"
	bluetooth_services_object_manager_set_global_state (_tmp3_, TRUE, NULL, NULL);
#line 224 "Plug.c"
}

static void
bluetooth_plug_real_hidden (SwitchboardPlug* base)
{
	BluetoothPlug * self;
	BluetoothServicesObjectManager* _tmp0_;
	BluetoothServicesObjectManager* _tmp1_;
	BluetoothServicesObjectManager* _tmp2_;
#line 53 "../src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 54 "../src/Plug.vala"
	_tmp0_ = self->priv->manager;
#line 54 "../src/Plug.vala"
	bluetooth_services_object_manager_unregister_agent (_tmp0_, NULL, NULL);
#line 55 "../src/Plug.vala"
	_tmp1_ = self->priv->manager;
#line 55 "../src/Plug.vala"
	bluetooth_services_object_manager_set_discoverable (_tmp1_, FALSE);
#line 56 "../src/Plug.vala"
	_tmp2_ = self->priv->manager;
#line 56 "../src/Plug.vala"
	bluetooth_services_object_manager_stop_discovery (_tmp2_, NULL, NULL);
#line 248 "Plug.c"
}

static void
bluetooth_plug_real_search_callback (SwitchboardPlug* base,
                                     const gchar* location)
{
	BluetoothPlug * self;
#line 59 "../src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 59 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 260 "Plug.c"
}

static void
bluetooth_plug_real_search_data_free (gpointer _data)
{
	BluetoothPlugSearchData* _data_;
	_data_ = _data;
#line 21 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 21 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 21 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/Plug.vala"
	g_slice_free (BluetoothPlugSearchData, _data_);
#line 276 "Plug.c"
}

static void
bluetooth_plug_real_search (SwitchboardPlug* base,
                            const gchar* search,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	BluetoothPlug * self;
	BluetoothPlugSearchData* _data_;
	BluetoothPlug* _tmp0_;
	gchar* _tmp1_;
#line 21 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 21 "../src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 21 "../src/Plug.vala"
	_data_ = g_slice_new0 (BluetoothPlugSearchData);
#line 21 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_plug_real_search_data_free);
#line 21 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 21 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 21 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 21 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 21 "../src/Plug.vala"
	bluetooth_plug_real_search_co (_data_);
#line 311 "Plug.c"
}

static GeeTreeMap*
bluetooth_plug_search_finish (SwitchboardPlug* base,
                              GAsyncResult* _res_)
{
	GeeTreeMap* result;
	BluetoothPlugSearchData* _data_;
#line 21 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 21 "../src/Plug.vala"
	result = _data_->result;
#line 21 "../src/Plug.vala"
	_data_->result = NULL;
#line 21 "../src/Plug.vala"
	return result;
#line 328 "Plug.c"
}

static gboolean
bluetooth_plug_real_search_co (BluetoothPlugSearchData* _data_)
{
#line 64 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 64 "../src/Plug.vala"
		case 0:
#line 338 "Plug.c"
		goto _state_0;
		default:
#line 64 "../src/Plug.vala"
		g_assert_not_reached ();
#line 343 "Plug.c"
	}
	_state_0:
#line 65 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 65 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 65 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 65 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 67 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 67 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 67 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 67 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 67 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 364 "Plug.c"
		}
	}
#line 67 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 67 "../src/Plug.vala"
	return FALSE;
#line 371 "Plug.c"
}

static void
bluetooth_plug_class_init (BluetoothPlugClass * klass,
                           gpointer klass_data)
{
#line 21 "../src/Plug.vala"
	bluetooth_plug_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothPlug_private_offset);
#line 21 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) bluetooth_plug_real_get_widget;
#line 21 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) bluetooth_plug_real_shown;
#line 21 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) bluetooth_plug_real_hidden;
#line 21 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) bluetooth_plug_real_search_callback;
#line 21 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) bluetooth_plug_real_search;
#line 21 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) bluetooth_plug_search_finish;
#line 21 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_plug_finalize;
#line 396 "Plug.c"
}

static void
bluetooth_plug_instance_init (BluetoothPlug * self,
                              gpointer klass)
{
#line 21 "../src/Plug.vala"
	self->priv = bluetooth_plug_get_instance_private (self);
#line 405 "Plug.c"
}

static void
bluetooth_plug_finalize (GObject * obj)
{
	BluetoothPlug * self;
#line 21 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_PLUG, BluetoothPlug);
#line 22 "../src/Plug.vala"
	_g_object_unref0 (self->priv->main_view);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (self->priv->manager);
#line 21 "../src/Plug.vala"
	G_OBJECT_CLASS (bluetooth_plug_parent_class)->finalize (obj);
#line 420 "Plug.c"
}

static GType
bluetooth_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothPlug), 0, (GInstanceInitFunc) bluetooth_plug_instance_init, NULL };
	GType bluetooth_plug_type_id;
	bluetooth_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "BluetoothPlug", &g_define_type_info, 0);
	BluetoothPlug_private_offset = g_type_add_instance_private (bluetooth_plug_type_id, sizeof (BluetoothPlugPrivate));
	return bluetooth_plug_type_id;
}

GType
bluetooth_plug_get_type (void)
{
	static volatile gsize bluetooth_plug_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_plug_type_id__once)) {
		GType bluetooth_plug_type_id;
		bluetooth_plug_type_id = bluetooth_plug_get_type_once ();
		g_once_init_leave (&bluetooth_plug_type_id__once, bluetooth_plug_type_id);
	}
	return bluetooth_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	BluetoothPlug* plug = NULL;
	BluetoothPlug* _tmp0_;
	SwitchboardPlug* result;
#line 71 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 72 "../src/Plug.vala"
	g_debug ("Plug.vala:72: Activating Bluetooth plug");
#line 73 "../src/Plug.vala"
	_tmp0_ = bluetooth_plug_new ();
#line 73 "../src/Plug.vala"
	plug = _tmp0_;
#line 74 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 74 "../src/Plug.vala"
	return result;
#line 463 "Plug.c"
}

